# AUTOGENERATED! DO NOT EDIT! File to edit: ../../nbs/11_utils.datasets.ipynb.

# %% auto 0
__all__ = ['download_file', 'load_mnist']

# %% ../../nbs/11_utils.datasets.ipynb 1
import os
import requests
import numpy as np

from matplotlib import pyplot as plt

# %% ../../nbs/11_utils.datasets.ipynb 3
def download_file(url, path):
    dir_path = os.path.dirname(path)

    os.makedirs(dir_path, exist_ok=True)
    if not os.path.exists(path):
        response = requests.get(url)
        with open(path, "wb") as f:
            f.write(response.content)


def load_mnist(path="../datasets/mnist/"):
    download_file(
        "https://storage.googleapis.com/tensorflow/tf-keras-datasets/mnist.npz",
        os.path.join(path, "mnist.npz"),
    )
    with np.load(os.path.join(path, "mnist.npz")) as f:
        x_train, y_train = f["x_train"], f["y_train"]
        x_test, y_test = f["x_test"], f["y_test"]
    return (x_train, y_train), (x_test, y_test)
